// @check-accepted: examples quadratic X=Y no-limits
#include <iostream>
#include <string>
#include <vector>
using namespace std;
using ll = long long;
const ll mod = 1e9 + 7;
const ll base = 3;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int N; cin >> N;
    string a, b;
    cin >> a >> b;

    vector<ll> p(N);
    p[0] = 1;
    for(int i = 1; i < N; ++i)p[i] = (p[i-1] * base)%mod;

    vector<ll> hasha(N+1), hashb(N+1);

    hasha[0] = hashb[0] = 0;

    for(int i = 0; i < N; ++i){
        hasha[i+1] = (hasha[i]*base + a[i] - '0' + 1)%mod;
        hashb[i+1] = (hashb[i]*base + 2 - b[i] + '0')%mod;
    }

    auto cmp = [&] (int al, int bl, int d) -> bool {
        ll ha = (hasha[al + d] - hasha[al] * p[d])%mod;
        ll hb = (hashb[bl + d] - hashb[bl] * p[d])%mod;
        return ((ha - hb + 3*mod)%mod) == 0;
    };

    int Q; cin >> Q;

    while(Q--){
        int al, bl, d;
        cin >> al >> bl >> d;
        int bs = 0;
        for(int i = 1<<20; i; i/=2){
            if(bs + i > d)continue;
            else if(cmp(al, bl, bs + i))bs += i;
        }
        if(bs == d)cout << 1 << ' ' ;
        else cout << (a[al + bs] == '0' ? 1 : 0) << ' ';
    }
    cout << endl;
}
