// @check-accepted: *
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>

using namespace std;

const int mod = 1000000007;

int n, q;
vector<pair<int, int> > v;

int fen[200002];
void add(int node)
{
    for(; node <= n; node += (node & (-node)))
        fen[node]++;
}
int compute(int node)
{
    int ans = 0;
    for(; node; node -= (node & (-node)))
        ans += fen[node];
    return ans;
}

long long pw(long long b, int e)
{
    long long ans = 1;
    while(e)
    {
        if(e & 1)
            ans = (ans * b) % mod;
        b = (b * b) % mod;
        e >>= 1;
    }
    return ans;
}

long long sol[200001];
struct queries
{
    int L, R, k, pos, ans;
};
queries vq[200001];

bool cmp(queries a, queries b)
{
    return a.ans > b.ans;
}

long long fenpw[200001];
void add_pw(int node, long long val)
{
    for(; node <= n; node += (node & (-node)))
        fenpw[node] = (fenpw[node] * val) % mod;
}

long long compute_prod(int node)
{
    long long ans = 1;
    for(; node; node -= (node & (-node)))
        ans = (ans * fenpw[node]) % mod;
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    cin >> n >> q;
    
    v.resize(n+1);
    for(int i = 1; i <= n; i++)
        cin >> v[i].first, v[i].second = i;
        
    sort(v.begin() + 1, v.begin() + n + 1);
    reverse(v.begin() + 1, v.begin() + n + 1);
        
    for(int i = 1; i <= q; i++)
    {
        cin >> vq[i].L >> vq[i].R >> vq[i].k;
        vq[i].L++, vq[i].R++;
        vq[i].ans = 200001;
        vq[i].pos = i;
    }
    
    for(int stp = 17; stp >= 0; stp--)
    {
        sort(vq + 1, vq + q + 1, cmp);
        memset(fen, 0, sizeof(fen));
        int curpos = 1;
        for(int j = 1; j <= q; j++)
        {
            while(curpos <= n && vq[j].ans - (1<<stp) <= v[curpos].first)
                add(v[curpos].second), curpos++;
            if(compute(vq[j].R) - compute(vq[j].L - 1) < vq[j].k)
                vq[j].ans -= (1<<stp);
        }
    }
    
    for(int i = 1; i <= q; i++)
        vq[i].ans--;
    
    sort(vq + 1, vq + q + 1, cmp);
    memset(fen, 0, sizeof(fen));
    for(int i = 1; i <= n; i++)
        fenpw[i] = 1;
    int curpos = 1;
    for(int j = 1; j <= q; j++)
    {
        while(curpos <= n && vq[j].ans <= v[curpos].first)
        {
            add_pw(v[curpos].second, v[curpos].first);
            add(v[curpos].second);
            curpos++;
        }
        long long cnt = compute(vq[j].R) - compute(vq[j].L - 1);
        long long prodd = compute_prod(vq[j].R) * pw(compute_prod(vq[j].L - 1), mod-2);
        prodd %= mod;
        
        
        if(cnt > vq[j].k)
            prodd = (prodd * pw(pw(vq[j].ans, cnt - vq[j].k), mod-2)) % mod;
        sol[vq[j].pos] = prodd;
    }
    
    for(int i = 1; i <= q; i++)
        cout << sol[i] << '\n';
    return 0;
}

